Orxonox: TiXmlDocument Class Reference

# TiXmlDocument Class Reference

`#include <src/tinyxml/tinyxml.h>`

Inheritance diagram for TiXmlDocument:

List of all members.

## Public Member Functions

virtual bool | Accept (TiXmlVisitor *content) const
void | ClearError ()
bool | Error () const
int | ErrorCol () const
| The column where the error occured. See ErrorRow().
const char * | ErrorDesc () const
| Contains a textual (english) description of the error if one occurs.
int | ErrorId () const
int | ErrorRow () const
bool | LoadFile (FILE *, TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
bool | LoadFile (const char *filename, TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
| Load a file using the given filename. Returns true if successful.
bool | LoadFile (TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
void | operator= (const TiXmlDocument &copy)
virtual const char * | Parse (const char *p, TiXmlParsingData *data=0, TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
virtual void | Print (FILE *cfile, int depth=0) const
| Print this Document to a FILE stream.
void | Print () const
TiXmlElement * | RootElement ()
const TiXmlElement * | RootElement () const
bool | SaveFile (FILE *) const
| Save a file using the given FILE*. Returns true if successful.
bool | SaveFile (const char *filename) const
| Save a file using the given filename. Returns true if successful.
bool | SaveFile () const
| Save a file using the current document value. Returns true if successful.
void | SetError (int err, const char *errorLocation, TiXmlParsingData *prevData, TiXmlEncoding encoding)
void | SetTabSize (int _tabsize)
int | TabSize () const
| TiXmlDocument (const TiXmlDocument &copy)
| TiXmlDocument (const char *documentName)
| Create a document with a name. The name of the document is also the filename of the xml.
| TiXmlDocument ()
| Create an empty document, that has no name.
virtual TiXmlDocument * | ToDocument ()
| Cast to a more defined type. Will return null not of the requested type.
virtual const TiXmlDocument * | ToDocument () const
| Cast to a more defined type. Will return null not of the requested type.
virtual | ~TiXmlDocument ()

## Protected Member Functions

virtual TiXmlNode * | Clone () const

## Private Member Functions

void | CopyTo (TiXmlDocument *target) const

## Private Attributes

bool | error
TIXML_STRING | errorDesc
int | errorId
TiXmlCursor | errorLocation
int | tabsize
bool | useMicrosoftBOM

## Detailed Description

Always the top level node. A document binds together all the XML pieces. It can be saved, loaded, and printed to the screen. The 'value' of a document node is the xml file name.

## Constructor & Destructor Documentation

TiXmlDocument::TiXmlDocument | ( |  | ) |

Create an empty document, that has no name.

References ClearError(), tabsize, and useMicrosoftBOM.

Referenced by Clone().

TiXmlDocument::TiXmlDocument | ( | const char * | documentName | ) |

Create a document with a name. The name of the document is also the filename of the xml.

References ClearError(), tabsize, useMicrosoftBOM, and TiXmlNode::value.

TiXmlDocument::TiXmlDocument | ( | const TiXmlDocument & | copy | ) |

References CopyTo().

virtual TiXmlDocument::~TiXmlDocument | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

bool TiXmlDocument::Accept | ( | TiXmlVisitor * | content | ) | const`[virtual]`

Walk the XML tree visiting this node and all of its children.

Implements TiXmlNode.

References TiXmlNode::FirstChild(), TiXmlVisitor::VisitEnter(), and TiXmlVisitor::VisitExit().

void TiXmlDocument::ClearError | ( |  | ) | `[inline]`

If you have handled the error, it can be reset with this call. The error state is automatically cleared if you Parse a new XML block.

References TiXmlCursor::col, error, errorDesc, errorId, errorLocation, and TiXmlCursor::row.

Referenced by Parse(), and TiXmlDocument().

TiXmlNode * TiXmlDocument::Clone | ( |  | ) | const`[protected, virtual]`

Create an exact duplicate of this node and return it. The memory must be deleted by the caller.

Implements TiXmlNode.

References CopyTo(), and TiXmlDocument().

void TiXmlDocument::CopyTo | ( | TiXmlDocument * | target | ) | const`[private]`

References TiXmlNode::Clone(), TiXmlNode::CopyTo(), error, errorDesc, errorId, errorLocation, TiXmlNode::firstChild, TiXmlNode::LinkEndChild(), TiXmlNode::NextSibling(), tabsize, and useMicrosoftBOM.

Referenced by Clone(), operator=(), and TiXmlDocument().

bool TiXmlDocument::Error | ( |  | ) | const`[inline]`

If an error occurs, Error will be set to true. Also,

- The ErrorId() will contain the integer identifier of the error (not generally useful)
- The ErrorDesc() method will return the name of the error. (very useful)
- The ErrorRow() and ErrorCol() will return the location of the error (if known)

References error.

Referenced by LoadFile().

int TiXmlDocument::ErrorCol | ( |  | ) | const`[inline]`

The column where the error occured. See ErrorRow().

References TiXmlCursor::col, and errorLocation.

const char* TiXmlDocument::ErrorDesc | ( |  | ) | const`[inline]`

Contains a textual (english) description of the error if one occurs.

References errorDesc.

int TiXmlDocument::ErrorId | ( |  | ) | const`[inline]`

Generally, you probably want the error string ( ErrorDesc() ). But if you prefer the ErrorId, this function will fetch it.

References errorId.

int TiXmlDocument::ErrorRow | ( |  | ) | const`[inline]`

Returns the location (if known) of the error. The first column is column 1, and the first row is row 1. A value of 0 means the row and column wasn't applicable (memory errors, for example, have no row/column) or the parser lost the error. (An error in the error reporting, in that case.)

See also:
  SetTabSize, Row, Column

References errorLocation, and TiXmlCursor::row.

bool TiXmlDocument::LoadFile | ( | FILE * | file,
|  | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING` |
| ) |  |  |

Load a file using the given FILE*. Returns true if successful. Note that this method doesn't stream - the entire object pointed at by the FILE* will be interpreted as an XML file. TinyXML doesn't stream in XML from the current file location. Streaming may be added in the future.

References TiXmlCursor::Clear(), TiXmlNode::Clear(), Error(), TiXmlBase::location, Parse(), SetError(), TIXML_ENCODING_UNKNOWN, TiXmlBase::TIXML_ERROR_DOCUMENT_EMPTY, TiXmlBase::TIXML_ERROR_OPENING_FILE, and TIXML_STRING.

bool TiXmlDocument::LoadFile | ( | const char * | filename,
|  | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING` |
| ) |  |  |

Load a file using the given filename. Returns true if successful.

References LoadFile(), SetError(), TIXML_ENCODING_UNKNOWN, TiXmlBase::TIXML_ERROR_OPENING_FILE, TIXML_STRING, TiXmlFOpen(), and TiXmlNode::value.

bool TiXmlDocument::LoadFile | ( | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING` | ) |

Load a file using the current document value. Returns true if successful. Will delete any existing document data before loading.

References TiXmlNode::Value().

Referenced by LoadFile().

void TiXmlDocument::operator= | ( | const TiXmlDocument & | copy | ) |

References TiXmlNode::Clear(), and CopyTo().

const char * TiXmlDocument::Parse | ( | const char * | p,
|  | TiXmlParsingData * | data = `0`,
|  | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING` |
| ) |  |  | `[virtual]`

Parse the given null terminated block of xml data. Passing in an encoding to this method (either TIXML_ENCODING_LEGACY or TIXML_ENCODING_UTF8 will force TinyXml to use that encoding, regardless of what TinyXml might otherwise try to detect.

Implements TiXmlBase.

References TiXmlCursor::Clear(), ClearError(), TiXmlCursor::col, TiXmlParsingData::Cursor(), TiXmlParsingData::cursor, TiXmlDeclaration::Encoding(), TiXmlNode::firstChild, TiXmlNode::Identify(), TiXmlNode::LinkEndChild(), TiXmlBase::location, TiXmlBase::Parse(), TiXmlCursor::row, SetError(), TiXmlBase::SkipWhiteSpace(), TiXmlBase::StringEqual(), TabSize(), TIXML_ENCODING_LEGACY, TIXML_ENCODING_UNKNOWN, TIXML_ENCODING_UTF8, TiXmlBase::TIXML_ERROR_DOCUMENT_EMPTY, TIXML_UTF_LEAD_0, TIXML_UTF_LEAD_1, TIXML_UTF_LEAD_2, TiXmlNode::ToDeclaration(), and useMicrosoftBOM.

Referenced by LoadFile().

void TiXmlDocument::Print | ( | FILE * | cfile,
|  | int | depth = `0` |
| ) |  |  | const`[virtual]`

Print this Document to a FILE stream.

Implements TiXmlBase.

References TiXmlNode::FirstChild(), and TiXmlAttribute::Print().

void TiXmlDocument::Print | ( |  | ) | const`[inline]`

Write the document to standard out using formatted printing ("pretty print").

Referenced by SaveFile().

TiXmlElement* TiXmlDocument::RootElement | ( |  | ) | `[inline]`

References TiXmlNode::FirstChildElement().

const TiXmlElement* TiXmlDocument::RootElement | ( |  | ) | const`[inline]`

Get the root element -- the only top level element -- of the document. In well formed XML, there should only be one. TinyXml is tolerant of multiple elements at the document level.

References TiXmlNode::FirstChildElement().

bool TiXmlDocument::SaveFile | ( | FILE * | fp | ) | const

Save a file using the given FILE*. Returns true if successful.

References Print(), TIXML_UTF_LEAD_0, TIXML_UTF_LEAD_1, TIXML_UTF_LEAD_2, orxonox::KeyCode::U, and useMicrosoftBOM.

bool TiXmlDocument::SaveFile | ( | const char * | filename | ) | const

Save a file using the given filename. Returns true if successful.

References SaveFile(), and TiXmlFOpen().

bool TiXmlDocument::SaveFile | ( |  | ) | const

Save a file using the current document value. Returns true if successful.

References TiXmlNode::Value().

Referenced by SaveFile().

void TiXmlDocument::SetError | ( | int | err,
|  | const char * | errorLocation,
|  | TiXmlParsingData * | prevData,
|  | TiXmlEncoding | encoding |
| ) |  |  |

References TiXmlCursor::Clear(), TiXmlParsingData::Cursor(), error, errorDesc, errorId, errorLocation, TiXmlBase::errorString, TiXmlParsingData::Stamp(), and TiXmlBase::TIXML_ERROR_STRING_COUNT.

Referenced by TiXmlNode::Identify(), TiXmlNode::InsertAfterChild(), TiXmlNode::InsertBeforeChild(), TiXmlNode::InsertEndChild(), TiXmlNode::LinkEndChild(), LoadFile(), TiXmlStylesheetReference::Parse(), TiXmlDeclaration::Parse(), TiXmlText::Parse(), TiXmlAttribute::Parse(), TiXmlComment::Parse(), TiXmlUnknown::Parse(), TiXmlElement::Parse(), Parse(), TiXmlElement::ReadValue(), and TiXmlElement::SetAttribute().

void TiXmlDocument::SetTabSize | ( | int | _tabsize | ) | `[inline]`

SetTabSize() allows the error reporting functions (ErrorRow() and ErrorCol()) to report the correct values for row and column. It does not change the output or input in any way.

By calling this method, with a tab size greater than 0, the row and column of each node and attribute is stored when the file is loaded. Very useful for tracking the DOM back in to the source file.

The tab size is required for calculating the location of nodes. If not set, the default of 4 is used. The tabsize is set per document. Setting the tabsize to 0 disables row/column tracking.

Note that row and column tracking is not supported when using operator>>.

The tab size needs to be enabled before the parse or load. Correct usage:

    		TiXmlDocument doc;
    		doc.SetTabSize( 8 );
    		doc.Load( "myfile.xml" );

See also:
  Row, Column

References tabsize.

int TiXmlDocument::TabSize | ( |  | ) | const`[inline]`

References tabsize.

Referenced by Parse().

virtual TiXmlDocument* TiXmlDocument::ToDocument | ( |  | ) | `[inline, virtual]`

Cast to a more defined type. Will return null not of the requested type.

Reimplemented from TiXmlNode.

virtual const TiXmlDocument* TiXmlDocument::ToDocument | ( |  | ) | const`[inline, virtual]`

Cast to a more defined type. Will return null not of the requested type.

Reimplemented from TiXmlNode.

## Member Data Documentation

bool TiXmlDocument::error`[private]`

Referenced by ClearError(), CopyTo(), Error(), and SetError().

TIXML_STRING TiXmlDocument::errorDesc`[private]`

Referenced by ClearError(), CopyTo(), ErrorDesc(), and SetError().

int TiXmlDocument::errorId`[private]`

Referenced by ClearError(), CopyTo(), ErrorId(), and SetError().

TiXmlCursor TiXmlDocument::errorLocation`[private]`

Referenced by ClearError(), CopyTo(), ErrorCol(), ErrorRow(), and SetError().

int TiXmlDocument::tabsize`[private]`

Referenced by CopyTo(), SetTabSize(), TabSize(), TiXmlDocument(), and TiXmlParsingData::TiXmlParsingData().

bool TiXmlDocument::useMicrosoftBOM`[private]`

Referenced by CopyTo(), Parse(), SaveFile(), and TiXmlDocument().

The documentation for this class was generated from the following files:

- src/tinyxml/tinyxml.h
- src/tinyxml/tinyxml.cpp
- src/tinyxml/tinyxmlparser.cpp